概述
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.InputOne line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).OutputOne line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
这道题的意思是从A变成B,但是中间的变换得是素数,运用了素数打表由于给定的就是一个四位数,把这四个数进行分离。
#include<stdio.h>
#include<string.h>
#include<queue>
#include<algorithm>
using namespace std;
int dis[10111],book[10111],n,m;
struct ha
{
int x,s;
}p,q;
void w()
{
memset(dis,0,sizeof(dis));
dis[1]=1;
for(int i=2;i<10111;i++)
{
if(!dis[i])
{
for(int j=i*2;j<10111;j=j+i)
dis[j]=1;
}
}
}
int dfs(int a,int b)
{
int num;
queue<ha>Q;
p.x=a;
p.s=0;
Q.push(p);
while(!Q.empty())
{
p=Q.front();
Q.pop();
if(p.x==b)
return p.s;
int to[5];
to[1]=p.x/1000;
to[2]=p.x/100%10;
to[3]=p.x/10%10;
to[4]=p.x%10;
for(int i=1;i<=4;i++)
{
int t=to[i];
for(int j=0;j<10;j++)
{
if(to[i]!=j)
{
to[i]=j;
num=to[1]*1000+to[2]*100+to[3]*10+to[4];
}
if(num>=1000&&num<=9999&&book[num]==0&&dis[num]==0)
{
q.x=num;
q.s=p.s+1;
Q.push(q);
book[num]=1;
}
}
to[i]=t;
}
}
return -10;
}
int main()
{
int t;
w();
scanf("%d",&t);
w();
while(t--)
{
scanf("%d%d",&n,&m);
memset(book,0,sizeof(book));
int sum=dfs(n,m);
if(sum!=-10)
printf("%dn",sum);
else
printf("Impossiblen");
}
return 0;
}
最后
以上就是细腻奇迹为你收集整理的搜索的全部内容,希望文章能够帮你解决搜索所遇到的程序开发问题。
如果觉得靠谱客网站的内容还不错,欢迎将靠谱客网站推荐给程序员好友。
发表评论 取消回复